From 38670b9a700e77bafa35137167a558c3ddb9d8d6 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Oct 04 2020 03:54:14 +0000
Subject: [PATCH 954/2232] Seal the Kind trait


This trait is not intended to be implementable outside of the cxx crate,
and by sealing we retain the ability to add methods or associated items
into the trait in the future without a breaking change.

---

diff --git a/src/extern_type.rs b/src/extern_type.rs
index b984f55..0432096 100644
--- a/src/extern_type.rs
+++ b/src/extern_type.rs
@@ -1,4 +1,4 @@
-use self::kind::Kind;
+use self::kind::{Kind, Opaque, Trivial};
 
 /// A type for which the layout is determined by its C++ definition.
 ///
@@ -146,6 +146,8 @@ pub unsafe trait ExternType {
 /// impls of the `ExternType` trait. Refer to the documentation of `Kind` for an
 /// overview of their purpose.
 pub mod kind {
+    use super::private;
+
     /// An opaque type which cannot be passed or held by value within Rust.
     ///
     /// Rust's move semantics are such that every move is equivalent to a
@@ -163,13 +165,19 @@ pub mod kind {
     /// indirection.
     pub enum Trivial {}
 
-    pub trait Kind {}
+    pub trait Kind: private::Sealed {}
     impl Kind for Opaque {}
     impl Kind for Trivial {}
 }
 
+mod private {
+    pub trait Sealed {}
+    impl Sealed for super::Opaque {}
+    impl Sealed for super::Trivial {}
+}
+
 #[doc(hidden)]
 pub fn verify_extern_type<T: ExternType<Id = Id>, Id>() {}
 
 #[doc(hidden)]
-pub fn verify_extern_kind<T: ExternType<Kind = Kind>, Kind>() {}
+pub fn verify_extern_kind<T: ExternType<Kind = Kind>, Kind: self::Kind>() {}

